//
// ArticlesAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class ArticlesAPI: APIBase {
    /**
     Account Article Report
     
     - parameter groupId: (query) A group ID to filter by (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func accountArticleReport(groupId groupId: Int64? = nil, completion: ((data: [AccountReport]?, error: ErrorType?) -> Void)) {
        accountArticleReportWithRequestBuilder(groupId: groupId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Account Article Report
     - GET /account/articles/export
     - Return status on all reports generated for the account from the oauth credentials
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter groupId: (query) A group ID to filter by (optional)

     - returns: RequestBuilder<[AccountReport]> 
     */
    public class func accountArticleReportWithRequestBuilder(groupId groupId: Int64? = nil) -> RequestBuilder<[AccountReport]> {
        let path = "/account/articles/export"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "group_id": groupId?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[AccountReport]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Initiate a new Report
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func accountArticleReportGenerate(completion: ((data: AccountReport?, error: ErrorType?) -> Void)) {
        accountArticleReportGenerateWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Initiate a new Report
     - POST /account/articles/export
     - Initiate a new Article Report for this Account. There is a limit of 1 report per day.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]

     - returns: RequestBuilder<AccountReport> 
     */
    public class func accountArticleReportGenerateWithRequestBuilder() -> RequestBuilder<AccountReport> {
        let path = "/account/articles/export"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<AccountReport>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     View article details
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articleDetails(articleId articleId: Int64, completion: ((data: ArticleComplete?, error: ErrorType?) -> Void)) {
        articleDetailsWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     View article details
     - GET /articles/{articleId}
     - View an article
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter articleId: (path) Article Unique identifier 

     - returns: RequestBuilder<ArticleComplete> 
     */
    public class func articleDetailsWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<ArticleComplete> {
        var path = "/articles/{articleId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ArticleComplete>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Article file details
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter fileId: (path) File Unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articleFileDetails(articleId articleId: Int64, fileId: Int64, completion: ((data: PublicFile?, error: ErrorType?) -> Void)) {
        articleFileDetailsWithRequestBuilder(articleId: articleId, fileId: fileId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Article file details
     - GET /articles/{articleId}/files/{fileId}
     - File by id
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter fileId: (path) File Unique identifier 

     - returns: RequestBuilder<PublicFile> 
     */
    public class func articleFileDetailsWithRequestBuilder(articleId articleId: Int64, fileId: Int64) -> RequestBuilder<PublicFile> {
        var path = "/articles/{articleId}/files/{fileId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{file_id}", withString: "\(fileId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PublicFile>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     List article files
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articleFiles(articleId articleId: Int64, completion: ((data: [PublicFile]?, error: ErrorType?) -> Void)) {
        articleFilesWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List article files
     - GET /articles/{articleId}/files
     - Files list for article
     - examples: [{contentType=application/json, example={}}]
     
     - parameter articleId: (path) Article Unique identifier 

     - returns: RequestBuilder<[PublicFile]> 
     */
    public class func articleFilesWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<[PublicFile]> {
        var path = "/articles/{articleId}/files"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[PublicFile]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Public Article Confidentiality for article version
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter vNumber: (path) Version Number 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articleVersionConfidentiality(articleId articleId: Int64, vNumber: Int64, completion: ((data: ArticleConfidentiality?, error: ErrorType?) -> Void)) {
        articleVersionConfidentialityWithRequestBuilder(articleId: articleId, vNumber: vNumber).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Article Confidentiality for article version
     - GET /articles/{articleId}/versions/{vNumber}/confidentiality
     - Confidentiality for article version. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter vNumber: (path) Version Number 

     - returns: RequestBuilder<ArticleConfidentiality> 
     */
    public class func articleVersionConfidentialityWithRequestBuilder(articleId articleId: Int64, vNumber: Int64) -> RequestBuilder<ArticleConfidentiality> {
        var path = "/articles/{articleId}/versions/{vNumber}/confidentiality"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{v_number}", withString: "\(vNumber)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ArticleConfidentiality>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Article details for version
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter vNumber: (path) Article Version Number 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articleVersionDetails(articleId articleId: Int64, vNumber: Int64, completion: ((data: ArticleComplete?, error: ErrorType?) -> Void)) {
        articleVersionDetailsWithRequestBuilder(articleId: articleId, vNumber: vNumber).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Article details for version
     - GET /articles/{articleId}/versions/{vNumber}
     - Article with specified version
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter vNumber: (path) Article Version Number 

     - returns: RequestBuilder<ArticleComplete> 
     */
    public class func articleVersionDetailsWithRequestBuilder(articleId articleId: Int64, vNumber: Int64) -> RequestBuilder<ArticleComplete> {
        var path = "/articles/{articleId}/versions/{vNumber}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{v_number}", withString: "\(vNumber)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ArticleComplete>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Public Article Embargo for article version
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter vNumber: (path) Version Number 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articleVersionEmbargo(articleId articleId: Int64, vNumber: Int64, completion: ((data: ArticleEmbargo?, error: ErrorType?) -> Void)) {
        articleVersionEmbargoWithRequestBuilder(articleId: articleId, vNumber: vNumber).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Article Embargo for article version
     - GET /articles/{articleId}/versions/{vNumber}/embargo
     - Embargo for article version
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter vNumber: (path) Version Number 

     - returns: RequestBuilder<ArticleEmbargo> 
     */
    public class func articleVersionEmbargoWithRequestBuilder(articleId articleId: Int64, vNumber: Int64) -> RequestBuilder<ArticleEmbargo> {
        var path = "/articles/{articleId}/versions/{vNumber}/embargo"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{v_number}", withString: "\(vNumber)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ArticleEmbargo>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Update article version
     
     - parameter articleId: (path) Article unique identifier 
     - parameter versionId: (path) Article version identifier 
     - parameter article: (body) Article description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articleVersionUpdate(articleId articleId: Int64, versionId: Int64, article: ArticleUpdate, completion: ((data: LocationWarningsUpdate?, error: ErrorType?) -> Void)) {
        articleVersionUpdateWithRequestBuilder(articleId: articleId, versionId: versionId, article: article).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Update article version
     - PUT /account/articles/{articleId}/versions/{versionId}/
     - Updating an article version by passing body parameters; request can also be made with the PATCH method.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter versionId: (path) Article version identifier 
     - parameter article: (body) Article description 

     - returns: RequestBuilder<LocationWarningsUpdate> 
     */
    public class func articleVersionUpdateWithRequestBuilder(articleId articleId: Int64, versionId: Int64, article: ArticleUpdate) -> RequestBuilder<LocationWarningsUpdate> {
        var path = "/account/articles/{articleId}/versions/{versionId}/"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{version_id}", withString: "\(versionId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = article.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<LocationWarningsUpdate>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Update article version thumbnail
     
     - parameter articleId: (path) Article unique identifier 
     - parameter versionId: (path) Article version identifier 
     - parameter fileId: (body) File ID 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articleVersionUpdateThumb(articleId articleId: Int64, versionId: Int64, fileId: FileId, completion: ((error: ErrorType?) -> Void)) {
        articleVersionUpdateThumbWithRequestBuilder(articleId: articleId, versionId: versionId, fileId: fileId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Update article version thumbnail
     - PUT /account/articles/{articleId}/versions/{versionId}/update_thumb
     - For a given public article version update the article thumbnail by choosing one of the associated files
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter versionId: (path) Article version identifier 
     - parameter fileId: (body) File ID 

     - returns: RequestBuilder<Void> 
     */
    public class func articleVersionUpdateThumbWithRequestBuilder(articleId articleId: Int64, versionId: Int64, fileId: FileId) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/versions/{versionId}/update_thumb"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{version_id}", withString: "\(versionId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = fileId.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     List article versions
     
     - parameter articleId: (path) Article Unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articleVersions(articleId articleId: Int64, completion: ((data: [ArticleVersions]?, error: ErrorType?) -> Void)) {
        articleVersionsWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List article versions
     - GET /articles/{articleId}/versions
     - List public article versions
     - examples: [{contentType=application/json, example={}}]
     
     - parameter articleId: (path) Article Unique identifier 

     - returns: RequestBuilder<[ArticleVersions]> 
     */
    public class func articleVersionsWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<[ArticleVersions]> {
        var path = "/articles/{articleId}/versions"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ArticleVersions]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     * enum for parameter order
     */
    public enum Order_articlesList: String { 
        case PublishedDate = "published_date"
        case CreatedDate = "created_date"
        case ModifiedDate = "modified_date"
        case Views = "views"
        case Shares = "shares"
        case Downloads = "downloads"
        case Cites = "cites"
    }

    /**
     * enum for parameter orderDirection
     */
    public enum OrderDirection_articlesList: String { 
        case Asc = "asc"
        case Desc = "desc"
    }

    /**
     Public Articles
     
     - parameter xCursor: (header) Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter order: (query) The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
     - parameter orderDirection: (query)  (optional, default to desc)
     - parameter institution: (query) only return articles from this institution (optional)
     - parameter publishedSince: (query) Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter modifiedSince: (query) Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter group: (query) only return articles from this group (optional)
     - parameter resourceDoi: (query) only return articles with this resource_doi (optional)
     - parameter itemType: (query) Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)
     - parameter doi: (query) only return articles with this doi (optional)
     - parameter handle: (query) only return articles with this handle (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articlesList(xCursor xCursor: NSUUID? = nil, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, order: Order_articlesList? = nil, orderDirection: OrderDirection_articlesList? = nil, institution: Int64? = nil, publishedSince: String? = nil, modifiedSince: String? = nil, group: Int64? = nil, resourceDoi: String? = nil, itemType: Int64? = nil, doi: String? = nil, handle: String? = nil, completion: ((data: [Article]?, error: ErrorType?) -> Void)) {
        articlesListWithRequestBuilder(xCursor: xCursor, page: page, pageSize: pageSize, limit: limit, offset: offset, order: order, orderDirection: orderDirection, institution: institution, publishedSince: publishedSince, modifiedSince: modifiedSince, group: group, resourceDoi: resourceDoi, itemType: itemType, doi: doi, handle: handle).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Articles
     - GET /articles
     - Returns a list of public articles
     - responseHeaders: [X-Cursor(String)]
     - examples: [{contentType=application/json, example={}}]
     
     - parameter xCursor: (header) Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter order: (query) The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
     - parameter orderDirection: (query)  (optional, default to desc)
     - parameter institution: (query) only return articles from this institution (optional)
     - parameter publishedSince: (query) Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter modifiedSince: (query) Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
     - parameter group: (query) only return articles from this group (optional)
     - parameter resourceDoi: (query) only return articles with this resource_doi (optional)
     - parameter itemType: (query) Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)
     - parameter doi: (query) only return articles with this doi (optional)
     - parameter handle: (query) only return articles with this handle (optional)

     - returns: RequestBuilder<[Article]> 
     */
    public class func articlesListWithRequestBuilder(xCursor xCursor: NSUUID? = nil, page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, order: Order_articlesList? = nil, orderDirection: OrderDirection_articlesList? = nil, institution: Int64? = nil, publishedSince: String? = nil, modifiedSince: String? = nil, group: Int64? = nil, resourceDoi: String? = nil, itemType: Int64? = nil, doi: String? = nil, handle: String? = nil) -> RequestBuilder<[Article]> {
        let path = "/articles"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "page": page?.encodeToJSON(),
            "page_size": pageSize?.encodeToJSON(),
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON(),
            "order": order?.rawValue,
            "order_direction": orderDirection?.rawValue,
            "institution": institution?.encodeToJSON(),
            "published_since": publishedSince,
            "modified_since": modifiedSince,
            "group": group?.encodeToJSON(),
            "resource_doi": resourceDoi,
            "item_type": itemType?.encodeToJSON(),
            "doi": doi,
            "handle": handle
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
        let nillableHeaders: [String: AnyObject?] = [
            "X-Cursor": xCursor
        ]
        let headerParameters = APIHelper.rejectNilHeaders(nillableHeaders)
 
        let requestBuilder: RequestBuilder<[Article]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false, headers: headerParameters)
    }

    /**
     Public Articles Search
     
     - parameter xCursor: (header) Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
     - parameter search: (body) Search Parameters (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func articlesSearch(xCursor xCursor: NSUUID? = nil, search: ArticleSearch? = nil, completion: ((data: [ArticleWithProject]?, error: ErrorType?) -> Void)) {
        articlesSearchWithRequestBuilder(xCursor: xCursor, search: search).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Public Articles Search
     - POST /articles/search
     - Returns a list of public articles, filtered by the search parameters
     - responseHeaders: [X-Cursor(String)]
     - examples: [{contentType=application/json, example={}}]
     
     - parameter xCursor: (header) Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
     - parameter search: (body) Search Parameters (optional)

     - returns: RequestBuilder<[ArticleWithProject]> 
     */
    public class func articlesSearchWithRequestBuilder(xCursor xCursor: NSUUID? = nil, search: ArticleSearch? = nil) -> RequestBuilder<[ArticleWithProject]> {
        let path = "/articles/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = search?.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
        let nillableHeaders: [String: AnyObject?] = [
            "X-Cursor": xCursor
        ]
        let headerParameters = APIHelper.rejectNilHeaders(nillableHeaders)
 
        let requestBuilder: RequestBuilder<[ArticleWithProject]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true, headers: headerParameters)
    }

    /**
     Delete article author
     
     - parameter articleId: (path) Article unique identifier 
     - parameter authorId: (path) Article Author unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleAuthorDelete(articleId articleId: Int64, authorId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateArticleAuthorDeleteWithRequestBuilder(articleId: articleId, authorId: authorId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Delete article author
     - DELETE /account/articles/{articleId}/authors/{authorId}
     - De-associate author from article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 
     - parameter authorId: (path) Article Author unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleAuthorDeleteWithRequestBuilder(articleId articleId: Int64, authorId: Int64) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/authors/{authorId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{author_id}", withString: "\(authorId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Add article authors
     
     - parameter articleId: (path) Article unique identifier 
     - parameter authors: (body) Authors description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleAuthorsAdd(articleId articleId: Int64, authors: AuthorsCreator, completion: ((error: ErrorType?) -> Void)) {
        privateArticleAuthorsAddWithRequestBuilder(articleId: articleId, authors: authors).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Add article authors
     - POST /account/articles/{articleId}/authors
     - Associate new authors with the article. This will add new authors to the list of already associated authors
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter authors: (body) Authors description 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleAuthorsAddWithRequestBuilder(articleId articleId: Int64, authors: AuthorsCreator) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/authors"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = authors.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     List article authors
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleAuthorsList(articleId articleId: Int64, completion: ((data: [Author]?, error: ErrorType?) -> Void)) {
        privateArticleAuthorsListWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List article authors
     - GET /account/articles/{articleId}/authors
     - List article authors
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<[Author]> 
     */
    public class func privateArticleAuthorsListWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<[Author]> {
        var path = "/account/articles/{articleId}/authors"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Author]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Replace article authors
     
     - parameter articleId: (path) Article unique identifier 
     - parameter authors: (body) Authors description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleAuthorsReplace(articleId articleId: Int64, authors: AuthorsCreator, completion: ((error: ErrorType?) -> Void)) {
        privateArticleAuthorsReplaceWithRequestBuilder(articleId: articleId, authors: authors).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Replace article authors
     - PUT /account/articles/{articleId}/authors
     - Associate new authors with the article. This will remove all already associated authors and add these new ones
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter authors: (body) Authors description 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleAuthorsReplaceWithRequestBuilder(articleId articleId: Int64, authors: AuthorsCreator) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/authors"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = authors.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Add article categories
     
     - parameter articleId: (path) Article unique identifier 
     - parameter categories: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleCategoriesAdd(articleId articleId: Int64, categories: CategoriesCreator, completion: ((error: ErrorType?) -> Void)) {
        privateArticleCategoriesAddWithRequestBuilder(articleId: articleId, categories: categories).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Add article categories
     - POST /account/articles/{articleId}/categories
     - Associate new categories with the article. This will add new categories to the list of already associated categories
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 
     - parameter categories: (body)  

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleCategoriesAddWithRequestBuilder(articleId articleId: Int64, categories: CategoriesCreator) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/categories"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = categories.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     List article categories
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleCategoriesList(articleId articleId: Int64, completion: ((data: [Category]?, error: ErrorType?) -> Void)) {
        privateArticleCategoriesListWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List article categories
     - GET /account/articles/{articleId}/categories
     - List article categories
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<[Category]> 
     */
    public class func privateArticleCategoriesListWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<[Category]> {
        var path = "/account/articles/{articleId}/categories"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Category]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Replace article categories
     
     - parameter articleId: (path) Article unique identifier 
     - parameter categories: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleCategoriesReplace(articleId articleId: Int64, categories: CategoriesCreator, completion: ((error: ErrorType?) -> Void)) {
        privateArticleCategoriesReplaceWithRequestBuilder(articleId: articleId, categories: categories).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Replace article categories
     - PUT /account/articles/{articleId}/categories
     - Associate new categories with the article. This will remove all already associated categories and add these new ones
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 
     - parameter categories: (body)  

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleCategoriesReplaceWithRequestBuilder(articleId articleId: Int64, categories: CategoriesCreator) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/categories"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = categories.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Delete article category
     
     - parameter articleId: (path) Article unique identifier 
     - parameter categoryId: (path) Category unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleCategoryDelete(articleId articleId: Int64, categoryId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateArticleCategoryDeleteWithRequestBuilder(articleId: articleId, categoryId: categoryId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Delete article category
     - DELETE /account/articles/{articleId}/categories/{categoryId}
     - De-associate category from article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 
     - parameter categoryId: (path) Category unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleCategoryDeleteWithRequestBuilder(articleId articleId: Int64, categoryId: Int64) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/categories/{categoryId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{category_id}", withString: "\(categoryId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Delete article confidentiality
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleConfidentialityDelete(articleId articleId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateArticleConfidentialityDeleteWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Delete article confidentiality
     - DELETE /account/articles/{articleId}/confidentiality
     - Delete confidentiality settings. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleConfidentialityDeleteWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/confidentiality"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Article confidentiality details
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleConfidentialityDetails(articleId articleId: Int64, completion: ((data: ArticleConfidentiality?, error: ErrorType?) -> Void)) {
        privateArticleConfidentialityDetailsWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Article confidentiality details
     - GET /account/articles/{articleId}/confidentiality
     - View confidentiality settings. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<ArticleConfidentiality> 
     */
    public class func privateArticleConfidentialityDetailsWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<ArticleConfidentiality> {
        var path = "/account/articles/{articleId}/confidentiality"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ArticleConfidentiality>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Update article confidentiality
     
     - parameter articleId: (path) Article unique identifier 
     - parameter reason: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleConfidentialityUpdate(articleId articleId: Int64, reason: ConfidentialityCreator, completion: ((error: ErrorType?) -> Void)) {
        privateArticleConfidentialityUpdateWithRequestBuilder(articleId: articleId, reason: reason).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Update article confidentiality
     - PUT /account/articles/{articleId}/confidentiality
     - Update confidentiality settings. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 
     - parameter reason: (body)  

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleConfidentialityUpdateWithRequestBuilder(articleId articleId: Int64, reason: ConfidentialityCreator) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/confidentiality"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = reason.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Create new Article
     
     - parameter article: (body) Article description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleCreate(article article: ArticleCreate, completion: ((data: LocationWarnings?, error: ErrorType?) -> Void)) {
        privateArticleCreateWithRequestBuilder(article: article).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Create new Article
     - POST /account/articles
     - Create a new Article by sending article information
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter article: (body) Article description 

     - returns: RequestBuilder<LocationWarnings> 
     */
    public class func privateArticleCreateWithRequestBuilder(article article: ArticleCreate) -> RequestBuilder<LocationWarnings> {
        let path = "/account/articles"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = article.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<LocationWarnings>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Delete article
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleDelete(articleId articleId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateArticleDeleteWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Delete article
     - DELETE /account/articles/{articleId}
     - Delete an article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleDeleteWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Article details
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleDetails(articleId articleId: Int64, completion: ((data: ArticleCompletePrivate?, error: ErrorType?) -> Void)) {
        privateArticleDetailsWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Article details
     - GET /account/articles/{articleId}
     - View a private article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<ArticleCompletePrivate> 
     */
    public class func privateArticleDetailsWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<ArticleCompletePrivate> {
        var path = "/account/articles/{articleId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ArticleCompletePrivate>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Delete Article Embargo
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleEmbargoDelete(articleId articleId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateArticleEmbargoDeleteWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Delete Article Embargo
     - DELETE /account/articles/{articleId}/embargo
     - Will lift the embargo for the specified article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleEmbargoDeleteWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/embargo"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Article Embargo Details
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleEmbargoDetails(articleId articleId: Int64, completion: ((data: ArticleEmbargo?, error: ErrorType?) -> Void)) {
        privateArticleEmbargoDetailsWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Article Embargo Details
     - GET /account/articles/{articleId}/embargo
     - View a private article embargo details
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<ArticleEmbargo> 
     */
    public class func privateArticleEmbargoDetailsWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<ArticleEmbargo> {
        var path = "/account/articles/{articleId}/embargo"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ArticleEmbargo>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Update Article Embargo
     
     - parameter articleId: (path) Article unique identifier 
     - parameter embargo: (body) Embargo description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleEmbargoUpdate(articleId articleId: Int64, embargo: ArticleEmbargoUpdater, completion: ((error: ErrorType?) -> Void)) {
        privateArticleEmbargoUpdateWithRequestBuilder(articleId: articleId, embargo: embargo).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Update Article Embargo
     - PUT /account/articles/{articleId}/embargo
     - Note: setting an article under whole embargo does not imply that the article will be published when the embargo will expire. You must explicitly call the publish endpoint to enable this functionality.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter embargo: (body) Embargo description 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleEmbargoUpdateWithRequestBuilder(articleId articleId: Int64, embargo: ArticleEmbargoUpdater) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/embargo"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = embargo.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Single File
     
     - parameter articleId: (path) Article unique identifier 
     - parameter fileId: (path) File unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleFile(articleId articleId: Int64, fileId: Int64, completion: ((data: PrivateFile?, error: ErrorType?) -> Void)) {
        privateArticleFileWithRequestBuilder(articleId: articleId, fileId: fileId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Single File
     - GET /account/articles/{articleId}/files/{fileId}
     - View details of file for specified article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter fileId: (path) File unique identifier 

     - returns: RequestBuilder<PrivateFile> 
     */
    public class func privateArticleFileWithRequestBuilder(articleId articleId: Int64, fileId: Int64) -> RequestBuilder<PrivateFile> {
        var path = "/account/articles/{articleId}/files/{fileId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{file_id}", withString: "\(fileId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PrivateFile>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     File Delete
     
     - parameter articleId: (path) Article unique identifier 
     - parameter fileId: (path) File unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleFileDelete(articleId articleId: Int64, fileId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateArticleFileDeleteWithRequestBuilder(articleId: articleId, fileId: fileId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     File Delete
     - DELETE /account/articles/{articleId}/files/{fileId}
     - Complete file upload
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 
     - parameter fileId: (path) File unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleFileDeleteWithRequestBuilder(articleId articleId: Int64, fileId: Int64) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/files/{fileId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{file_id}", withString: "\(fileId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     List article files
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleFilesList(articleId articleId: Int64, completion: ((data: [PrivateFile]?, error: ErrorType?) -> Void)) {
        privateArticleFilesListWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List article files
     - GET /account/articles/{articleId}/files
     - List private files
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<[PrivateFile]> 
     */
    public class func privateArticleFilesListWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<[PrivateFile]> {
        var path = "/account/articles/{articleId}/files"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[PrivateFile]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     List private links
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticlePrivateLink(articleId articleId: Int64, completion: ((data: [PrivateLink]?, error: ErrorType?) -> Void)) {
        privateArticlePrivateLinkWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     List private links
     - GET /account/articles/{articleId}/private_links
     - List private links
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<[PrivateLink]> 
     */
    public class func privateArticlePrivateLinkWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<[PrivateLink]> {
        var path = "/account/articles/{articleId}/private_links"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[PrivateLink]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Create private link
     
     - parameter articleId: (path) Article unique identifier 
     - parameter privateLink: (body)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticlePrivateLinkCreate(articleId articleId: Int64, privateLink: PrivateLinkCreator? = nil, completion: ((data: PrivateLinkResponse?, error: ErrorType?) -> Void)) {
        privateArticlePrivateLinkCreateWithRequestBuilder(articleId: articleId, privateLink: privateLink).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Create private link
     - POST /account/articles/{articleId}/private_links
     - Create new private link for this article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter privateLink: (body)  (optional)

     - returns: RequestBuilder<PrivateLinkResponse> 
     */
    public class func privateArticlePrivateLinkCreateWithRequestBuilder(articleId articleId: Int64, privateLink: PrivateLinkCreator? = nil) -> RequestBuilder<PrivateLinkResponse> {
        var path = "/account/articles/{articleId}/private_links"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = privateLink?.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PrivateLinkResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Disable private link
     
     - parameter articleId: (path) Article unique identifier 
     - parameter linkId: (path) Private link token 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticlePrivateLinkDelete(articleId articleId: Int64, linkId: String, completion: ((error: ErrorType?) -> Void)) {
        privateArticlePrivateLinkDeleteWithRequestBuilder(articleId: articleId, linkId: linkId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Disable private link
     - DELETE /account/articles/{articleId}/private_links/{linkId}
     - Disable/delete private link for this article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 
     - parameter linkId: (path) Private link token 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticlePrivateLinkDeleteWithRequestBuilder(articleId articleId: Int64, linkId: String) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/private_links/{linkId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{link_id}", withString: "\(linkId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Update private link
     
     - parameter articleId: (path) Article unique identifier 
     - parameter linkId: (path) Private link token 
     - parameter privateLink: (body)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticlePrivateLinkUpdate(articleId articleId: Int64, linkId: String, privateLink: PrivateLinkCreator? = nil, completion: ((error: ErrorType?) -> Void)) {
        privateArticlePrivateLinkUpdateWithRequestBuilder(articleId: articleId, linkId: linkId, privateLink: privateLink).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Update private link
     - PUT /account/articles/{articleId}/private_links/{linkId}
     - Update existing private link for this article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter linkId: (path) Private link token 
     - parameter privateLink: (body)  (optional)

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticlePrivateLinkUpdateWithRequestBuilder(articleId articleId: Int64, linkId: String, privateLink: PrivateLinkCreator? = nil) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/private_links/{linkId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{link_id}", withString: "\(linkId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = privateLink?.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Article Publish
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticlePublish(articleId articleId: Int64, completion: ((data: Location?, error: ErrorType?) -> Void)) {
        privateArticlePublishWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Article Publish
     - POST /account/articles/{articleId}/publish
     - - If the whole article is under embargo, it will not be published immediately, but when the embargo expires or is lifted. - When an article is published, a new public version will be generated. Any further updates to the article will affect the private article data. In order to make these changes publicly visible, an explicit publish operation is needed.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<Location> 
     */
    public class func privateArticlePublishWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<Location> {
        var path = "/account/articles/{articleId}/publish"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Location>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Article Reserve DOI
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleReserveDoi(articleId articleId: Int64, completion: ((data: ArticleDOI?, error: ErrorType?) -> Void)) {
        privateArticleReserveDoiWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Article Reserve DOI
     - POST /account/articles/{articleId}/reserve_doi
     - Reserve DOI for article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<ArticleDOI> 
     */
    public class func privateArticleReserveDoiWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<ArticleDOI> {
        var path = "/account/articles/{articleId}/reserve_doi"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ArticleDOI>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Article Reserve Handle
     
     - parameter articleId: (path) Article unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleReserveHandle(articleId articleId: Int64, completion: ((data: ArticleHandle?, error: ErrorType?) -> Void)) {
        privateArticleReserveHandleWithRequestBuilder(articleId: articleId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Article Reserve Handle
     - POST /account/articles/{articleId}/reserve_handle
     - Reserve Handle for article
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 

     - returns: RequestBuilder<ArticleHandle> 
     */
    public class func privateArticleReserveHandleWithRequestBuilder(articleId articleId: Int64) -> RequestBuilder<ArticleHandle> {
        var path = "/account/articles/{articleId}/reserve_handle"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ArticleHandle>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Article Resource
     
     - parameter articleId: (path) Article unique identifier 
     - parameter resource: (body) Resource data 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleResource(articleId articleId: Int64, resource: Resource, completion: ((data: Location?, error: ErrorType?) -> Void)) {
        privateArticleResourceWithRequestBuilder(articleId: articleId, resource: resource).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Article Resource
     - POST /account/articles/{articleId}/resource
     - Edit article resource data.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter resource: (body) Resource data 

     - returns: RequestBuilder<Location> 
     */
    public class func privateArticleResourceWithRequestBuilder(articleId articleId: Int64, resource: Resource) -> RequestBuilder<Location> {
        var path = "/account/articles/{articleId}/resource"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = resource.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Location>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Update article
     
     - parameter articleId: (path) Article unique identifier 
     - parameter article: (body) Article description 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleUpdate(articleId articleId: Int64, article: ArticleUpdate, completion: ((data: LocationWarningsUpdate?, error: ErrorType?) -> Void)) {
        privateArticleUpdateWithRequestBuilder(articleId: articleId, article: article).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Update article
     - PUT /account/articles/{articleId}
     - Updating an article by passing body parameters; request can also be made with the PATCH method.
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter article: (body) Article description 

     - returns: RequestBuilder<LocationWarningsUpdate> 
     */
    public class func privateArticleUpdateWithRequestBuilder(articleId articleId: Int64, article: ArticleUpdate) -> RequestBuilder<LocationWarningsUpdate> {
        var path = "/account/articles/{articleId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = article.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<LocationWarningsUpdate>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Complete Upload
     
     - parameter articleId: (path) Article unique identifier 
     - parameter fileId: (path) File unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleUploadComplete(articleId articleId: Int64, fileId: Int64, completion: ((error: ErrorType?) -> Void)) {
        privateArticleUploadCompleteWithRequestBuilder(articleId: articleId, fileId: fileId).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Complete Upload
     - POST /account/articles/{articleId}/files/{fileId}
     - Complete file upload
     - OAuth:
       - type: oauth2
       - name: OAuth2
     
     - parameter articleId: (path) Article unique identifier 
     - parameter fileId: (path) File unique identifier 

     - returns: RequestBuilder<Void> 
     */
    public class func privateArticleUploadCompleteWithRequestBuilder(articleId articleId: Int64, fileId: Int64) -> RequestBuilder<Void> {
        var path = "/account/articles/{articleId}/files/{fileId}"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{file_id}", withString: "\(fileId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Initiate Upload
     
     - parameter articleId: (path) Article unique identifier 
     - parameter file: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticleUploadInitiate(articleId articleId: Int64, file: FileCreator, completion: ((data: Location?, error: ErrorType?) -> Void)) {
        privateArticleUploadInitiateWithRequestBuilder(articleId: articleId, file: file).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Initiate Upload
     - POST /account/articles/{articleId}/files
     - Initiate a new file upload within the article. Either use the link property to point to an existing file that resides elsewhere and will not be uploaded to Figshare or use the other 3 parameters (md5, name, size).
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - responseHeaders: [Location(String)]
     - examples: [{contentType=application/json, example={"empty": false}}]
     
     - parameter articleId: (path) Article unique identifier 
     - parameter file: (body)  

     - returns: RequestBuilder<Location> 
     */
    public class func privateArticleUploadInitiateWithRequestBuilder(articleId articleId: Int64, file: FileCreator) -> RequestBuilder<Location> {
        var path = "/account/articles/{articleId}/files"
        path = path.stringByReplacingOccurrencesOfString("{article_id}", withString: "\(articleId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = file.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Location>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Private Articles
     
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticlesList(page page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil, completion: ((data: [Article]?, error: ErrorType?) -> Void)) {
        privateArticlesListWithRequestBuilder(page: page, pageSize: pageSize, limit: limit, offset: offset).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Articles
     - GET /account/articles
     - Get Own Articles
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter page: (query) Page number. Used for pagination with page_size (optional)
     - parameter pageSize: (query) The number of results included on a page. Used for pagination with page (optional, default to 10)
     - parameter limit: (query) Number of results included on a page. Used for pagination with query (optional)
     - parameter offset: (query) Where to start the listing(the offset of the first result). Used for pagination with limit (optional)

     - returns: RequestBuilder<[Article]> 
     */
    public class func privateArticlesListWithRequestBuilder(page page: Int64? = nil, pageSize: Int64? = nil, limit: Int64? = nil, offset: Int64? = nil) -> RequestBuilder<[Article]> {
        let path = "/account/articles"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "page": page?.encodeToJSON(),
            "page_size": pageSize?.encodeToJSON(),
            "limit": limit?.encodeToJSON(),
            "offset": offset?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Article]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Private Articles search
     
     - parameter search: (body) Search Parameters 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateArticlesSearch(search search: PrivateArticleSearch, completion: ((data: [ArticleWithProject]?, error: ErrorType?) -> Void)) {
        privateArticlesSearchWithRequestBuilder(search: search).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Private Articles search
     - POST /account/articles/search
     - Returns a list of private articles filtered by the search parameters
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter search: (body) Search Parameters 

     - returns: RequestBuilder<[ArticleWithProject]> 
     */
    public class func privateArticlesSearchWithRequestBuilder(search search: PrivateArticleSearch) -> RequestBuilder<[ArticleWithProject]> {
        let path = "/account/articles/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = search.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[ArticleWithProject]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

}
