//
// AuthorsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class AuthorsAPI: APIBase {
    /**
     Author details
     
     - parameter authorId: (path) Author unique identifier 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateAuthorDetails(authorId authorId: Int64, completion: ((data: AuthorComplete?, error: ErrorType?) -> Void)) {
        privateAuthorDetailsWithRequestBuilder(authorId: authorId).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Author details
     - GET /account/authors/{authorId}
     - View author details
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={
  "blank": true,
  "bytes": [],
  "empty": true
}}]
     
     - parameter authorId: (path) Author unique identifier 

     - returns: RequestBuilder<AuthorComplete> 
     */
    public class func privateAuthorDetailsWithRequestBuilder(authorId authorId: Int64) -> RequestBuilder<AuthorComplete> {
        var path = "/account/authors/{authorId}"
        path = path.stringByReplacingOccurrencesOfString("{author_id}", withString: "\(authorId)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<AuthorComplete>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Search Authors
     
     - parameter search: (body) Search Parameters (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func privateAuthorsSearch(search search: PrivateAuthorsSearch? = nil, completion: ((data: [Author]?, error: ErrorType?) -> Void)) {
        privateAuthorsSearchWithRequestBuilder(search: search).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Search Authors
     - POST /account/authors/search
     - Search for authors
     - OAuth:
       - type: oauth2
       - name: OAuth2
     - examples: [{contentType=application/json, example={}}]
     
     - parameter search: (body) Search Parameters (optional)

     - returns: RequestBuilder<[Author]> 
     */
    public class func privateAuthorsSearchWithRequestBuilder(search search: PrivateAuthorsSearch? = nil) -> RequestBuilder<[Author]> {
        let path = "/account/authors/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = search?.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Author]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

}
