//
// ArticleComplete.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class ArticleComplete: JSONEncodable {
    /** Article citation */
    public var citation: String?
    /** Confidentiality reason */
    public var confidentialReason: String?
    /** Article Confidentiality */
    public var isConfidential: Bool?
    /** Article size */
    public var size: Int64?
    /** Article funding */
    public var funding: String?
    /** Full Article funding information */
    public var fundingList: [FundingInformation]?
    /** List of article tags */
    public var tags: [String]?
    /** Article version */
    public var version: Int64?
    /** True if article is active */
    public var isActive: Bool?
    /** True if article has no files */
    public var isMetadataRecord: Bool?
    /** Article metadata reason */
    public var metadataReason: String?
    /** Article status */
    public var status: String?
    /** Article description */
    public var description: String?
    /** True if article is embargoed */
    public var isEmbargoed: Bool?
    /** True if article is published */
    public var isPublic: Bool?
    /** Date when article was created */
    public var createdDate: String?
    /** True if any files are linked to the article */
    public var hasLinkedFile: Bool?
    /** List of categories selected for the article */
    public var categories: [Category]?
    /** Article selected license */
    public var license: License?
    /** Title for embargo */
    public var embargoTitle: String?
    /** Reason for embargo */
    public var embargoReason: String?
    /** List of references */
    public var references: [String]?
    /** List of related materials; supersedes references and resource DOI/title. */
    public var relatedMaterials: [RelatedMaterial]?
    /** Unique identifier for article */
    public var id: Int64?
    /** Title of article */
    public var title: String?
    /** DOI */
    public var doi: String?
    /** Handle */
    public var handle: String?
    /** Api endpoint for article */
    public var url: String?
    /** Public site endpoint for article */
    public var urlPublicHtml: String?
    /** Public Api endpoint for article */
    public var urlPublicApi: String?
    /** Private site endpoint for article */
    public var urlPrivateHtml: String?
    /** Private Api endpoint for article */
    public var urlPrivateApi: String?
    /** Various timeline dates */
    public var timeline: Timeline?
    /** Thumbnail image */
    public var thumb: String?
    /** Type of article identifier */
    public var definedType: Int64?
    /** Name of the article type identifier */
    public var definedTypeName: String?
    /** Article public url */
    public var figshareUrl: String?
    /** If true, downloading of files for this article is disabled */
    public var downloadDisabled: Bool?
    /** List of article files */
    public var files: [PublicFile]?
    /** List of article authors */
    public var authors: [Author]?
    /** List of custom fields values */
    public var customFields: [CustomArticleField]?
    /** List of embargo options */
    public var embargoOptions: [GroupEmbargoOptions]?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["citation"] = self.citation
        nillableDictionary["confidential_reason"] = self.confidentialReason
        nillableDictionary["is_confidential"] = self.isConfidential
        nillableDictionary["size"] = self.size?.encodeToJSON()
        nillableDictionary["funding"] = self.funding
        nillableDictionary["funding_list"] = self.fundingList?.encodeToJSON()
        nillableDictionary["tags"] = self.tags?.encodeToJSON()
        nillableDictionary["version"] = self.version?.encodeToJSON()
        nillableDictionary["is_active"] = self.isActive
        nillableDictionary["is_metadata_record"] = self.isMetadataRecord
        nillableDictionary["metadata_reason"] = self.metadataReason
        nillableDictionary["status"] = self.status
        nillableDictionary["description"] = self.description
        nillableDictionary["is_embargoed"] = self.isEmbargoed
        nillableDictionary["is_public"] = self.isPublic
        nillableDictionary["created_date"] = self.createdDate
        nillableDictionary["has_linked_file"] = self.hasLinkedFile
        nillableDictionary["categories"] = self.categories?.encodeToJSON()
        nillableDictionary["license"] = self.license?.encodeToJSON()
        nillableDictionary["embargo_title"] = self.embargoTitle
        nillableDictionary["embargo_reason"] = self.embargoReason
        nillableDictionary["references"] = self.references?.encodeToJSON()
        nillableDictionary["related_materials"] = self.relatedMaterials?.encodeToJSON()
        nillableDictionary["id"] = self.id?.encodeToJSON()
        nillableDictionary["title"] = self.title
        nillableDictionary["doi"] = self.doi
        nillableDictionary["handle"] = self.handle
        nillableDictionary["url"] = self.url
        nillableDictionary["url_public_html"] = self.urlPublicHtml
        nillableDictionary["url_public_api"] = self.urlPublicApi
        nillableDictionary["url_private_html"] = self.urlPrivateHtml
        nillableDictionary["url_private_api"] = self.urlPrivateApi
        nillableDictionary["timeline"] = self.timeline?.encodeToJSON()
        nillableDictionary["thumb"] = self.thumb
        nillableDictionary["defined_type"] = self.definedType?.encodeToJSON()
        nillableDictionary["defined_type_name"] = self.definedTypeName
        nillableDictionary["figshare_url"] = self.figshareUrl
        nillableDictionary["download_disabled"] = self.downloadDisabled
        nillableDictionary["files"] = self.files?.encodeToJSON()
        nillableDictionary["authors"] = self.authors?.encodeToJSON()
        nillableDictionary["custom_fields"] = self.customFields?.encodeToJSON()
        nillableDictionary["embargo_options"] = self.embargoOptions?.encodeToJSON()
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
