//
// ArticleCreate.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class ArticleCreate: JSONEncodable {
    /** Title of article */
    public var title: String?
    /** The article description. In a publisher case, usually this is the remote article description */
    public var description: String?
    /** True if article has no files */
    public var isMetadataRecord: Bool?
    /** Article metadata reason */
    public var metadataReason: String?
    /** List of tags to be associated with the article. Keywords can be used instead */
    public var tags: [String]?
    /** List of tags to be associated with the article. Tags can be used instead */
    public var keywords: [String]?
    /** List of links to be associated with the article (e.g [\&quot;http://link1\&quot;, \&quot;http://link2\&quot;, \&quot;http://link3\&quot;]) */
    public var references: [String]?
    /** List of related materials; supersedes references and resource DOI/title. */
    public var relatedMaterials: [RelatedMaterial]?
    /** List of category ids to be associated with the article(e.g [1, 23, 33, 66]) */
    public var categories: [Int64]?
    /** List of category source ids to be associated with the article, supersedes the categories property */
    public var categoriesBySourceId: [String]?
    /** List of authors to be associated with the article. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint. */
    public var authors: [AnyObject]?
    /** List of key, values pairs to be associated with the article */
    public var customFields: AnyObject?
    /** List of custom fields values, supersedes custom_fields parameter */
    public var customFieldsList: [CustomArticleFieldAdd]?
    /** &lt;b&gt;One of:&lt;/b&gt; &lt;code&gt;figure&lt;/code&gt; &lt;code&gt;online resource&lt;/code&gt; &lt;code&gt;preprint&lt;/code&gt; &lt;code&gt;book&lt;/code&gt; &lt;code&gt;conference contribution&lt;/code&gt; &lt;code&gt;media&lt;/code&gt; &lt;code&gt;dataset&lt;/code&gt; &lt;code&gt;poster&lt;/code&gt; &lt;code&gt;journal contribution&lt;/code&gt; &lt;code&gt;presentation&lt;/code&gt; &lt;code&gt;thesis&lt;/code&gt; &lt;code&gt;software&lt;/code&gt; */
    public var definedType: String?
    /** Grant number or funding authority */
    public var funding: String?
    /** Funding creation / update items */
    public var fundingList: [FundingCreate]?
    /** License id for this article. */
    public var license: Int64?
    /** Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system. */
    public var doi: String?
    /** Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system. */
    public var handle: String?
    /** Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article DOI. */
    public var resourceDoi: String?
    /** Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article title. */
    public var resourceTitle: String?
    /** Various timeline dates */
    public var timeline: TimelineUpdate?
    /** Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups */
    public var groupId: Int64?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["title"] = self.title
        nillableDictionary["description"] = self.description
        nillableDictionary["is_metadata_record"] = self.isMetadataRecord
        nillableDictionary["metadata_reason"] = self.metadataReason
        nillableDictionary["tags"] = self.tags?.encodeToJSON()
        nillableDictionary["keywords"] = self.keywords?.encodeToJSON()
        nillableDictionary["references"] = self.references?.encodeToJSON()
        nillableDictionary["related_materials"] = self.relatedMaterials?.encodeToJSON()
        nillableDictionary["categories"] = self.categories?.encodeToJSON()
        nillableDictionary["categories_by_source_id"] = self.categoriesBySourceId?.encodeToJSON()
        nillableDictionary["authors"] = self.authors?.encodeToJSON()
        nillableDictionary["custom_fields"] = self.customFields
        nillableDictionary["custom_fields_list"] = self.customFieldsList?.encodeToJSON()
        nillableDictionary["defined_type"] = self.definedType
        nillableDictionary["funding"] = self.funding
        nillableDictionary["funding_list"] = self.fundingList?.encodeToJSON()
        nillableDictionary["license"] = self.license?.encodeToJSON()
        nillableDictionary["doi"] = self.doi
        nillableDictionary["handle"] = self.handle
        nillableDictionary["resource_doi"] = self.resourceDoi
        nillableDictionary["resource_title"] = self.resourceTitle
        nillableDictionary["timeline"] = self.timeline?.encodeToJSON()
        nillableDictionary["group_id"] = self.groupId?.encodeToJSON()
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
