//
// ArticleEmbargoUpdater.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class ArticleEmbargoUpdater: JSONEncodable {
    public enum EmbargoType: String { 
        case Article = "article"
        case File = "file"
    }
    /** Embargo status */
    public var isEmbargoed: Bool?
    /** Date when the embargo expires and the article gets published, &#39;0&#39; value will set up permanent embargo */
    public var embargoDate: String?
    /** Embargo can be enabled at the article or the file level. Possible values: article, file */
    public var embargoType: EmbargoType?
    /** Title for embargo */
    public var embargoTitle: String?
    /** Reason for setting embargo */
    public var embargoReason: String?
    /** List of embargo permissions to be associated with the article. The list must contain &#x60;id&#x60; and can also contain &#x60;group_ids&#x60;(a field that only applies to &#39;logged_in&#39; permissions). The new list replaces old options in the database, and an empty list removes all permissions for this article. Administration permission has to be set up alone but logged in and IP range permissions can be set up together. */
    public var embargoOptions: [AnyObject]?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["is_embargoed"] = self.isEmbargoed
        nillableDictionary["embargo_date"] = self.embargoDate
        nillableDictionary["embargo_type"] = self.embargoType?.rawValue
        nillableDictionary["embargo_title"] = self.embargoTitle
        nillableDictionary["embargo_reason"] = self.embargoReason
        nillableDictionary["embargo_options"] = self.embargoOptions?.encodeToJSON()
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
