//
// ArticleSearch.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class ArticleSearch: JSONEncodable {
    public enum OrderDirection: String { 
        case Asc = "asc"
        case Desc = "desc"
    }
    public enum Order: String { 
        case CreatedDate = "created_date"
        case PublishedDate = "published_date"
        case ModifiedDate = "modified_date"
        case Views = "views"
        case Shares = "shares"
        case Downloads = "downloads"
        case Cites = "cites"
    }
    /** Search term */
    public var searchFor: String?
    /** Page number. Used for pagination with page_size */
    public var page: Int64?
    /** The number of results included on a page. Used for pagination with page */
    public var pageSize: Int64?
    /** Number of results included on a page. Used for pagination with query */
    public var limit: Int64?
    /** Where to start the listing(the offset of the first result). Used for pagination with limit */
    public var offset: Int64?
    /** Direction of ordering */
    public var orderDirection: OrderDirection?
    /** only return collections from this institution */
    public var institution: Int32?
    /** Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD */
    public var publishedSince: String?
    /** Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD */
    public var modifiedSince: String?
    /** only return collections from this group */
    public var group: Int32?
    /** Only return articles with this resource_doi */
    public var resourceDoi: String?
    /** Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model */
    public var itemType: Int64?
    /** Only return articles with this doi */
    public var doi: String?
    /** Only return articles with this handle */
    public var handle: String?
    /** Only return articles in this project */
    public var projectId: Int64?
    /** The field by which to order */
    public var order: Order?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["search_for"] = self.searchFor
        nillableDictionary["page"] = self.page?.encodeToJSON()
        nillableDictionary["page_size"] = self.pageSize?.encodeToJSON()
        nillableDictionary["limit"] = self.limit?.encodeToJSON()
        nillableDictionary["offset"] = self.offset?.encodeToJSON()
        nillableDictionary["order_direction"] = self.orderDirection?.rawValue
        nillableDictionary["institution"] = self.institution?.encodeToJSON()
        nillableDictionary["published_since"] = self.publishedSince
        nillableDictionary["modified_since"] = self.modifiedSince
        nillableDictionary["group"] = self.group?.encodeToJSON()
        nillableDictionary["resource_doi"] = self.resourceDoi
        nillableDictionary["item_type"] = self.itemType?.encodeToJSON()
        nillableDictionary["doi"] = self.doi
        nillableDictionary["handle"] = self.handle
        nillableDictionary["project_id"] = self.projectId?.encodeToJSON()
        nillableDictionary["order"] = self.order?.rawValue
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
