//
// CollectionUpdate.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class CollectionUpdate: JSONEncodable {
    /** Grant number or funding authority */
    public var funding: String?
    /** Funding creation / update items */
    public var fundingList: [FundingCreate]?
    /** Title of collection */
    public var title: String?
    /** The collection description. In a publisher case, usually this is the remote collection description */
    public var description: String?
    /** List of articles to be associated with the collection */
    public var articles: [Int32]?
    /** List of authors to be associated with the collection. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint. */
    public var authors: [AnyObject]?
    /** List of category ids to be associated with the collection (e.g [1, 23, 33, 66]) */
    public var categories: [Int64]?
    /** List of category source ids to be associated with the article, supersedes the categories property */
    public var categoriesBySourceId: [String]?
    /** List of tags to be associated with the collection. Keywords can be used instead */
    public var tags: [String]?
    /** List of tags to be associated with the collection. Tags can be used instead */
    public var keywords: [String]?
    /** List of links to be associated with the collection (e.g [\&quot;http://link1\&quot;, \&quot;http://link2\&quot;, \&quot;http://link3\&quot;]) */
    public var references: [String]?
    /** List of key, values pairs to be associated with the collection */
    public var customFields: AnyObject?
    /** List of custom fields values, supersedes custom_fields parameter */
    public var customFieldsList: [CustomArticleFieldAdd]?
    /** Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system. */
    public var doi: String?
    /** Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system. */
    public var handle: String?
    /** Not applicable to regular users. In a publisher case, this is the publisher article id */
    public var resourceId: String?
    /** Not applicable to regular users. In a publisher case, this is the publisher article DOI. */
    public var resourceDoi: String?
    /** Not applicable to regular users. In a publisher case, this is the publisher article link */
    public var resourceLink: String?
    /** Not applicable to regular users. In a publisher case, this is the publisher article title. */
    public var resourceTitle: String?
    /** Not applicable to regular users. In a publisher case, this is the publisher article version */
    public var resourceVersion: Int32?
    /** Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups */
    public var groupId: Int64?
    /** Various timeline dates */
    public var timeline: TimelineUpdate?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["funding"] = self.funding
        nillableDictionary["funding_list"] = self.fundingList?.encodeToJSON()
        nillableDictionary["title"] = self.title
        nillableDictionary["description"] = self.description
        nillableDictionary["articles"] = self.articles?.encodeToJSON()
        nillableDictionary["authors"] = self.authors?.encodeToJSON()
        nillableDictionary["categories"] = self.categories?.encodeToJSON()
        nillableDictionary["categories_by_source_id"] = self.categoriesBySourceId?.encodeToJSON()
        nillableDictionary["tags"] = self.tags?.encodeToJSON()
        nillableDictionary["keywords"] = self.keywords?.encodeToJSON()
        nillableDictionary["references"] = self.references?.encodeToJSON()
        nillableDictionary["custom_fields"] = self.customFields
        nillableDictionary["custom_fields_list"] = self.customFieldsList?.encodeToJSON()
        nillableDictionary["doi"] = self.doi
        nillableDictionary["handle"] = self.handle
        nillableDictionary["resource_id"] = self.resourceId
        nillableDictionary["resource_doi"] = self.resourceDoi
        nillableDictionary["resource_link"] = self.resourceLink
        nillableDictionary["resource_title"] = self.resourceTitle
        nillableDictionary["resource_version"] = self.resourceVersion?.encodeToJSON()
        nillableDictionary["group_id"] = self.groupId?.encodeToJSON()
        nillableDictionary["timeline"] = self.timeline?.encodeToJSON()
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
